;-- http://radiohlam.ru -  ,   
;------------------------------------------------------------------
 list    p = 12f629
 __config 01FE4h          ;  01111 11 1 1 0 0 100 - (7,8)  , (6)   ,
                          ;  (5)GP3/-MCLR   -MCLR, (4)PWRT , (3)  - , (2-0) - 
;*********  ************************************
         CBLOCK 0x20      ;    
         MBC              ;    ( - 889uS)
         LBC              ;   
         Counter2         ;   
         Counter1         ; 
         Counter3         ;
         ENDC             ;
;********  ***************************************
T1         equ         .212        ;  1
T2         equ         .2
TP         equ         .200        ;     
Tn         equ         .50         ;   (   )
Sys        equ         .253        ;   (29) + 2SB=1 + TB=1
CMD_1      equ         .1          ;   1
CMD_2      equ         .2          ;   2
CMD_3      equ         .3          ;   3
CMD_4      equ         .4          ;   4
Status     equ         03h         ;   .
GPIO       equ         05h         ;    .
Cmcon      equ         19h         ;  Cmcon - 
TrisIO     equ         05h         ;      .
INTCON     equ         0Bh         ;  (1)/(0) 
OSCCAL     equ         10h         ;    
F          equ         1           ;    .
;********************************************************
;    GP0 (1- ), GP1(2- ), GP2(), GP4() -     , GP5 -  -
;********************************************************

          org 0
;********   ********************************************************
;***  ,      , **********
;***    , OSCCAL    03FFh,     BOR - *
;*** 12-,13-    (   BOR - 01, OSCCAL - 346C)*****************
;******   *****************************************************************
;******   *****************************************************
start       bsf         Status,5         ;
            Call        3FFh             ;     w
            movwf       OSCCAL           ;
;********    GP5 -  ,  GP4-GP0 -   ********************
            bcf         Status,5         ;    0
            clrf        GPIO             ;  
            movlw       .7               ;  0..2 
            movwf       Cmcon            ;  , GP0, GP1, GP2 -  /
            bsf         Status,5         ;   1-  (  1 5-   Status).
            movlw       .40              ;   GPIO   (W)    .40=00 101000 GP0, GP1, GP2, GP4 - ,  - 
            movwf       TrisIO           ;   GPIO  W   TrisIO.
            bcf         Status,5         ;    0
            bsf         INTCON,3
;******     ***********************************************
Scan       btfss   GPIO,5              ;  5-    -  , 
           call    priem
           btfsc   MBC,7               ;  start  (7-)   MBC = 1,    
           call    rab_chast           ;
           bcf     INTCON,0
           sleep
           goto Scan                   ;

;*****   ***************************************************************
priem         clrf MBC
              clrf LBC
;***********************************************************************************
              movlw Tn
              movwf Counter3
wait_n        nop
              decfsz Counter3,1
              goto wait_n
;*********   ***********************************************************
              btfss  GPIO,5          ;    GP5  - 
              bsf MBC,7
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf MBC,6
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf MBC,5
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf MBC,4
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf MBC,3
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf MBC,2
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf MBC,1
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf MBC,0
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf LBC,5
              call wait
;*********   ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf LBC,4
              call wait
;*********    ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf LBC,3
              call wait
;*********    ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf LBC,2
              call wait
;*********    ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf LBC,1
              call wait
;*********    ***********************************************************
              btfss GPIO,5          ;    GP5  - 
              bsf LBC,0
              call wait
         return

;*******  ***********************************************************************
wait              movlw   T2
                  movwf   Counter2
pause2            movlw   T1
                  movwf   Counter1
pause1            nop
                  decfsz  Counter1,1
                  goto pause1
                  decfsz Counter2,1
                  goto pause2
                  return
;******************************************************************************************
;*******   ********************************************************************
;*******    **********************************************************
rab_chast         movlw     Sys
                  xorwf     MBC,0
                  btfss     Status,2        ;   2 (Z)   Status=1,      (   )
                  goto      out             ;
;*******   1 *********************************************************
                  movlw     CMD_1
                  xorwf     LBC,0           ;
                  btfss     Status,2        ;   2 (Z)   Status=1,     
                  goto      com2            ;
                  movlw     b'11101001'
                  andwf     GPIO,1
                  movlw     b'00000001'
                  xorwf     GPIO,1
                  goto  out
;******   2 ***********************************************
com2              movlw     CMD_2
                  xorwf     LBC,0           ;
                  btfss     Status,2        ;   2 (Z)   Status=1,     
                  goto      com3            ;
                  movlw     b'11101010'
                  andwf     GPIO,1
                  movlw     b'00000010'
                  xorwf     GPIO,1                 
                  goto      out
;*******   3 ********************************************************
com3              movlw     CMD_3
                  xorwf     LBC,0           ;
                  btfss     Status,2        ;   2 (Z)   Status=1,     
                  goto      com4            ;
                  movlw     b'11101100'
                  andwf     GPIO,1
                  movlw     b'00000100'
                  xorwf     GPIO,1
                  goto      out
;*******   4 ********************************************************
com4              movlw     CMD_4
                  xorwf     LBC,0           ;
                  btfss     Status,2        ;   2 (Z)   Status=1,     
                  goto      out             ;
                  movlw     b'11111000'
                  andwf     GPIO,1
                  movlw     b'00010000'
                  xorwf     GPIO,1
;*******     ******************************
out         bcf           MBC,7          ;    
;*******  ****************************************************************************
                  movlw   TP
                  movwf   Counter3
pauset            call wait
                  decfsz Counter3,1
                  goto pauset
                  return
 end
